<?php
/**
 * @package FishPig_WordPress
 * @author  Ben Tideswell (ben@fishpig.com)
 * @url     https://fishpig.co.uk/magento/wordpress-integration/
 */
declare(strict_types=1);

namespace FishPig\WordPress\Model;

class Config
{
    /**
     * @auto
     */
    protected $scopeConfig = null;

    /**
     * @return void
     */
    public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    ) {
        $this->scopeConfig = $scopeConfig;
    }
    
    /**
     * @return bool
     */
    public function isThemeIntegrationEnabled(): bool
    {
        return $this->scopeConfig->isSetFlag('wordpress/setup/theme_integration');
    }
}
